// styles shared by form/input components
.select, .button, .input {
  display: flex;
  align-items: center;
  justify-content: center;
  white-space: nowrap;
  * + * {
    margin-left: spacing(1);
  }
  &.small {
    height: spacing(3);
	}
	&.regular {
    height: spacing(4);
	}
	&.large {
    height: spacing(5);
  }
  &.full-width {
    width: 100%;
    justify-content: space-between;
  }
}

.select, .button, .input, .textarea {
  &.small {
		padding: spacing(0) spacing(1);
	}
	&.regular {
		padding: spacing(1) spacing(2);
	}
	&.large {
		padding: 1.5rem spacing(3);
  }
}

.input, .textarea {
  width: 100%;
  &::placeholder {
    color: color(grey);
  }
}

.checkbox, .radio {
  position: relative;
  // hide native input
  input {
    opacity: 0;
  }
  // input size/position (native and faux)
  input, .text::before {
    position: absolute;
    top: 0;
    left: 0;
    width: 1.5rem;
    height: 1.5rem;
  }
  .text {
    display: block;
    padding-left: spacing(3);
    line-height: $line-height-body;
    // faux input
    &::before {
      content: "";
    }
    // checkmark icon
    svg {
      position: absolute;
      top: 4px;
      left: 5px;
      color: color(primary);
      opacity: 0; // hidden until checked – styles below
      transition: $transition;
    }
  }
}

// add cursor
.checkbox .text,
.radio .text,
.option {
  cursor: pointer;
}

// box style: default
.select,
.input,
.textarea,
.checkbox .text::before {
  border: border(grey-light);
  border-radius: $border-radius;
  background: color(white);
  transition: $transition;
}

// box style: hover
.select:hover,
.input:hover,
.textarea:hover,
.checkbox input:hover + .text::before {
  border-color: color(primary);
  box-shadow: $box-shadow;
}

// box style: focus
.select:focus,
.input:focus,
.input:focus-within,
.textarea:focus,
.checkbox input:focus + .text::before {
  border-color: color(primary);
  box-shadow: $box-shadow;
  outline: Highlight auto 1px;
  outline-color: -webkit-focus-ring-color;
}

// box style: selected/active/checked
.select.selected,
.input.active,
.checkbox.checked .text::before,
.option.checked .text::before {
  border-color: color(primary);
  background: color(primary-tint);
}
.checkbox.checked,
.option.checked {
  svg {
    opacity: 1;
  }
}

// box style: disabled
.select.disabled,
.select.disabled:hover,
.input.disabled,
.input.disabled:hover,
.textarea.disabled,
.textarea.disabled:hover,
.checkbox.disabled .text::before ,
.checkbox.disabled input:hover + .text::before {
  border-color: color(grey-light);
  background: color(grey-light);
  box-shadow: none;
}
.select.disabled,
.input.disabled,
.textarea.disabled,
.checkbox.disabled .text {
  color: color(grey);
  cursor: not-allowed;
}

// box style: error
.select.error,
.invalid .select,
.input.error,
.textarea.error,
.checkbox.error input + .text::before {
  border-color: color(danger-dark);
  background: color(danger-tint);
}
